import wx

class EyePanel(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent, style=wx.BORDER_SUNKEN)
        self.colors = [None, None]
    
    def update(self, colors):
        self.colors = colors
        self.draw()
    
    def draw(self):
        dc = wx.ClientDC(self)
        w, h = dc.GetSize()
        num = len(self.colors)
        scale = min(w / num, h)
        y = scale / 2
        x = scale / 2
        radius = scale / 2
        for color in self.colors:
            dc.SetBrush(wx.Brush(color))
            dc.DrawCircle(x, y, radius)
            x += scale
 