import wx
from random import random
class Grass:
    def __init__(self, operator, parent=None):
        self.amount = 0.01
        if parent == None:
            print "New grass at a random spot."
            #self.color = (0, 100 + int(156.0 * random()), 0)
            self.color = (0, 255, 0)
            self.x = random()
            self.y = random()
        else:
            print "New grass close by."
            #self.amount = 0.3 * random()
            self.x = parent.x + (random() - 0.5) / 6.0
            if self.x < 0.0:
                self.x = 0.0
            elif self.x > 1.0:
                self.x = 1.0
            self.y = parent.y + (random() - 0.5) / 6.0
            if self.y < 0.0:
                self.y = 0.0
            elif self.y > 1.0:
                self.y = 1.0
            self.color = parent.color
        self.operator = operator
        self.size = self._compute_size()
        
    def _compute_size(self):
        return self.amount * .02
    
    def draw(self, dc, scale):
        #scale = min(dc.GetSize())
        x = self.x * scale
        y = self.y * scale
        radius = self.size * scale
        #color = wx.Color(0, (255.0 * self.amount), 0)
        dc.SetBrush(wx.Brush(wx.Color(self.color[0], self.color[1], self.color[2])))
        dc.DrawCircle(x, y, radius)
    
    def grow(self):
        self.amount += 0.0023
        if self.amount > 1.0:
            self.amount = 1.0
            #if random() > 0.95:
        self.size = self._compute_size()
        rand = random()
        if rand > .9992:
            self.operator.reproduce_grass(self)
                #if grass != None:
                #    self.amount = self.amount - new_grass.amount
            
    def shrink(self, amount):
        """ Return actual amount eaten """
        init_amount = self.amount
        if amount > 0.0:
            self.amount -= amount
        elif self.amount < 0.0:
            self.amount = 0.0
        self.size = self._compute_size()
        return init_amount - self.amount

